
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "cgilib.h"

void main(int argc, char *argv[])
{
	/* Variables for the data. */
	
	char *data = (char *) 0;
	Dictionary dataDict = 0;
	const char *choice = 0;
	FILE *in = 0;
	char buffer[1024];
	int actual = 0;
	
	/* Write the content type */
	
	printf("Content-type: text/plain\n\n");
	
	/*
	* Create a dictionary to hold the data.
	*/
	
	dataDict = dict_alloc();
	
	/*
	 * Read the data, passing the string data by reference.
	 * readData() will alloc space for it. readData() will also determine
	 * the request type.
	 */
	
	readData(&data);
		
	/*
	 * Call parseData() to break the data into key-value pairs.
	 * This function will print the pairs.
	 */
	if(data) parseData(data,dataDict);

	choice = (const char *)dict_valueForKey(dataDict,"choice");
	
	if(choice && !strcmp(choice,"library"))
	  {
	    in = fopen("cgilib.c","r");
	  }
	else
	  {
	    in = fopen("locdoc.c","r");
	  }

	while(!feof(in))
	{
		actual = fread(buffer,sizeof(char),1024,in);
		fwrite(buffer,sizeof(char),actual,stdout);
	}

	
	fclose(in);
	if(data) free(data);
	
	dict_free(dataDict);
	
	/* End the program */
	exit(0);
}

